/**
 */
package de.prototype.dsl.pcmx.base;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see de.prototype.dsl.pcmx.base.BaseFactory
 * @model kind="package"
 * @generated
 */
public interface BasePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "base";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://example.org/base";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "base";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BasePackage eINSTANCE = de.prototype.dsl.pcmx.base.impl.BasePackageImpl.init();

	/**
	 * The meta object id for the '{@link de.prototype.dsl.pcmx.base.impl.MxModelImpl <em>Mx Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see de.prototype.dsl.pcmx.base.impl.MxModelImpl
	 * @see de.prototype.dsl.pcmx.base.impl.BasePackageImpl#getMxModel()
	 * @generated
	 */
	int MX_MODEL = 0;

	/**
	 * The feature id for the '<em><b>Entity Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MX_MODEL__ENTITY_NAME = 0;

	/**
	 * The number of structural features of the '<em>Mx Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MX_MODEL_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Mx Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MX_MODEL_OPERATION_COUNT = 0;


	/**
	 * Returns the meta object for class '{@link de.prototype.dsl.pcmx.base.MxModel <em>Mx Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mx Model</em>'.
	 * @see de.prototype.dsl.pcmx.base.MxModel
	 * @generated
	 */
	EClass getMxModel();

	/**
	 * Returns the meta object for the attribute '{@link de.prototype.dsl.pcmx.base.MxModel#getEntityName <em>Entity Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Entity Name</em>'.
	 * @see de.prototype.dsl.pcmx.base.MxModel#getEntityName()
	 * @see #getMxModel()
	 * @generated
	 */
	EAttribute getMxModel_EntityName();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	BaseFactory getBaseFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link de.prototype.dsl.pcmx.base.impl.MxModelImpl <em>Mx Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see de.prototype.dsl.pcmx.base.impl.MxModelImpl
		 * @see de.prototype.dsl.pcmx.base.impl.BasePackageImpl#getMxModel()
		 * @generated
		 */
		EClass MX_MODEL = eINSTANCE.getMxModel();

		/**
		 * The meta object literal for the '<em><b>Entity Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MX_MODEL__ENTITY_NAME = eINSTANCE.getMxModel_EntityName();

	}

} //BasePackage
